/*     */ package petascope.wcs2.extensions;
/*     */ 
/*     */ import com.sun.media.jai.codec.ByteArraySeekableStream;
/*     */ import com.sun.media.jai.codec.ImageCodec;
/*     */ import com.sun.media.jai.codec.ImageDecoder;
/*     */ import com.sun.media.jai.codec.SeekableStream;
/*     */ import com.sun.media.jai.codec.TIFFDecodeParam;
/*     */ import java.awt.geom.Rectangle2D.Float;
/*     */ import java.awt.image.BufferedImage;
/*     */ import java.awt.image.ColorModel;
/*     */ import java.awt.image.Raster;
/*     */ import java.awt.image.RenderedImage;
/*     */ import java.awt.image.WritableRaster;
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.PrintStream;
/*     */ import java.util.Hashtable;
/*     */ import java.util.List;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ import javax.media.jai.NullOpImage;
/*     */ import org.geotools.coverage.grid.GridCoverage2D;
/*     */ import org.geotools.coverage.grid.GridCoverageFactory;
/*     */ import org.geotools.gce.geotiff.GeoTiffWriter;
/*     */ import org.geotools.geometry.Envelope2D;
/*     */ import org.geotools.referencing.CRS;
/*     */ import org.opengis.referencing.FactoryException;
/*     */ import org.opengis.referencing.NoSuchAuthorityCodeException;
/*     */ import petascope.core.DbMetadataSource;
/*     */ import petascope.exceptions.ExceptionCode;
/*     */ import petascope.exceptions.WCSException;
/*     */ import petascope.util.Pair;
/*     */ import petascope.util.ras.RasQueryResult;
/*     */ import petascope.wcs2.handlers.Response;
/*     */ import petascope.wcs2.parsers.GetCoverageMetadata;
/*     */ import petascope.wcs2.parsers.GetCoverageRequest;
/*     */ 
/*     */ public class GeotiffFormatExtension extends AbstractFormatExtension
/*     */ {
/*     */   public boolean canHandle(GetCoverageRequest req)
/*     */   {
/*  70 */     return ((!(req.isMultipart())) && ("image/tiff".equals(req.getFormat())));
/*     */   }
/*     */ 
/*     */   public Response handle(GetCoverageRequest request, DbMetadataSource meta) throws WCSException
/*     */   {
/*  75 */     GetCoverageMetadata m = new GetCoverageMetadata(request, meta);
/*  76 */     setBounds(request, m, meta);
/*  77 */     if ((m.getGridDimension().intValue() != 2) || ((!(m.getCoverageType().equals("GridCoverage"))) && (!(m.getCoverageType().equals("RectifiedGridCoverage")))))
/*     */     {
/*  79 */       throw new WCSException(ExceptionCode.NoApplicableCode, "The GeoTIFF format extension only supports GridCoverage and RectifiedGridCoverage with exactly two dimensions");
/*     */     }
/*     */ 
/*  83 */     Pair p = null;
/*  84 */     if (m.getCoverageType().equals("GridCoverage"))
/*     */     {
/*  86 */       p = executeRasqlQuery(request, m, meta, "tiff", null);
/*     */     }
/*     */     else {
/*  89 */       p = executeRasqlQuery(request, m, meta, "tiff", null);
/*     */     }
/*  91 */     RasQueryResult res = new RasQueryResult(p.fst);
/*  92 */     if (res.getMdds().isEmpty()) {
/*  93 */       return new Response(null, null, "image/tiff");
/*     */     }
/*     */ 
/*  96 */     System.out.println("to georef is " + this.prop.toGeoref + " " + (float)this.prop.highX + " " + this.prop.highY + " " + this.prop.lowX + " " + this.prop.lowY);
/*  97 */     if (this.prop.toGeoref.booleanValue()) {
/*  98 */       byte[] test = (byte[])res.getMdds().get(0);
/*  99 */       SeekableStream s = null;
/* 100 */       RenderedImage op = null;
/*     */       try {
/* 102 */         s = new ByteArraySeekableStream(test);
/* 103 */         TIFFDecodeParam param = null;
/* 104 */         ImageDecoder dec = ImageCodec.createImageDecoder("TIFF", s, param);
/* 105 */         System.out.println("height is " + dec.decodeAsRaster().getHeight());
/* 106 */         op = new NullOpImage(dec.decodeAsRenderedImage(0), null, null, 2);
/* 107 */         System.out.println("width " + op.getWidth() + " height " + op.getHeight());
/*     */       } catch (IOException ex) {
/* 109 */         Logger.getLogger(GeotiffFormatExtension.class.getName()).log(Level.SEVERE, null, ex);
/*     */       }
/* 111 */       BufferedImage bi = convertRenderedImage(op);
/* 112 */       Envelope2D envelope = null;
/*     */       try {
/* 114 */         envelope = new Envelope2D(CRS.decode("EPSG:4326"), new Rectangle2D.Float((float)this.prop.lowX, (float)this.prop.lowY, (float)(this.prop.highX - this.prop.lowX), (float)(this.prop.highY - this.prop.lowY)));
/*     */       }
/*     */       catch (NoSuchAuthorityCodeException ex) {
/* 117 */         Logger.getLogger(GeotiffFormatExtension.class.getName()).log(Level.SEVERE, null, ex);
/*     */       } catch (FactoryException ex) {
/* 119 */         Logger.getLogger(GeotiffFormatExtension.class.getName()).log(Level.SEVERE, null, ex);
/*     */       }
/* 121 */       GridCoverage2D cov = new GridCoverageFactory().create("BMImage", bi, envelope);
/*     */ 
/* 124 */       ByteArrayOutputStream oos = new ByteArrayOutputStream();
/* 125 */       GeoTiffWriter writer = null;
/*     */       try {
/* 127 */         writer = new GeoTiffWriter(oos);
/* 128 */         writer.write(cov, null);
/*     */       } catch (IOException ex) {
/* 130 */         Logger.getLogger(GeotiffFormatExtension.class.getName()).log(Level.SEVERE, null, ex);
/*     */       }
/* 132 */       return new Response(oos.toByteArray(), null, "image/tiff"); }
/* 133 */     return new Response((byte[])res.getMdds().get(0), null, "image/tiff");
/*     */   }
/*     */ 
/*     */   public BufferedImage convertRenderedImage(RenderedImage img)
/*     */   {
/* 138 */     if (img instanceof BufferedImage) {
/* 139 */       return ((BufferedImage)img);
/*     */     }
/* 141 */     ColorModel cm = img.getColorModel();
/* 142 */     int width = img.getWidth();
/* 143 */     int height = img.getHeight();
/* 144 */     WritableRaster raster = cm.createCompatibleWritableRaster(width, height);
/* 145 */     boolean isAlphaPremultiplied = cm.isAlphaPremultiplied();
/* 146 */     Hashtable properties = new Hashtable();
/* 147 */     String[] keys = img.getPropertyNames();
/* 148 */     if (keys != null) {
/* 149 */       for (int i = 0; i < keys.length; ++i) {
/* 150 */         properties.put(keys[i], img.getProperty(keys[i]));
/*     */       }
/*     */     }
/* 153 */     BufferedImage result = new BufferedImage(cm, raster, isAlphaPremultiplied, properties);
/* 154 */     img.copyData(raster);
/* 155 */     return result;
/*     */   }
/*     */ 
/*     */   public String getExtensionIdentifier()
/*     */   {
/* 160 */     return "http://www.opengis.net/spec/WCS_coverage-encoding_geotiff/1.0/";
/*     */   }
/*     */ }

/* Location:           /home/dimitar/projects/rasdaman/community/backup/classes/
 * Qualified Name:     petascope.wcs2.extensions.GeotiffFormatExtension
 * JD-Core Version:    0.5.3
 */